/*
* OpenGL - 3D Vision Wrapper
* Copyright (c) Helifax 2015
*/

#ifndef H_OPENGL32_ARB_EXTENSION__
#define H_OPENGL32_ARB_EXTENSION__

extern "C" {
#include "opengl_3dv.h"
}
#include <stdio.h>
#include <direct.h>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <thread>
#include <mutex>

#include "opengl32.h"
#include "include\ShaderManager.h"
#include "windows.h"
#include "d3d9.h"
#include "NVAPI_367\nvapi.h"
#include "FPSInject/FPSInject.h"
#include "MessageBox\MessageBox.h"
#include "ConfigReader.h"

// ARB variants of the OpenGl wrapper functions
void sys_glAttachObjectARB(GLuint program, GLuint shader);
void sys_glLinkProgramARB(GLhandleARB program);
void sys_glUseProgramObjectARB(GLhandleARB program);

// Helper functions to get variables from the main opengl32.cpp file
GLuint GetCurrentGeneratedProgramVertex(void);
GLuint GetCurrentGeneratedProgramPixel(void);
GLuint GetCurrentVertexShaderId(void);
GLuint GetCurrentPixelShaderId(void);

// Set functions (Implementation in opengl32.cpp)
void SetCurrentGeneratedProgramVertex(GLuint value);
void SetCurrentGeneratedProgramPixel(GLuint value);
void SetCurrentVertexShaderId(GLuint value);
void SetCurrentPixelShaderId(GLuint value);


#endif